'use strict';

var _require = require('lodash');

var defaults = _require.defaults;
var pick = _require.pick;

var promisify = require('es6-promisify');
var defaultDefault = require('./default-default');

module.exports = function contentFromFilename(github, config) {
  var _config, branch, filename, addRepo, head, _ref, tree, _tree$find, sha, blob;

  return regeneratorRuntime.async(function contentFromFilename$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        config = defaults(config, {
          branch: 'master'
        });

        _config = config;
        branch = _config.branch;
        filename = _config.filename;
        addRepo = defaultDefault(pick(config, ['user', 'repo']));
        context$1$0.prev = 5;
        context$1$0.next = 8;
        return regeneratorRuntime.awrap(promisify(github.gitdata.getReference)(addRepo({ ref: 'heads/' + branch })));

      case 8:
        head = context$1$0.sent;
        context$1$0.next = 11;
        return regeneratorRuntime.awrap(promisify(github.gitdata.getTree)(addRepo({ sha: head.object.sha })));

      case 11:
        _ref = context$1$0.sent;
        tree = _ref.tree;
        _tree$find = tree.find(function (object) {
          return object.path === filename;
        });
        sha = _tree$find.sha;

        if (sha) {
          context$1$0.next = 17;
          break;
        }

        return context$1$0.abrupt('return', Promise.reject(new Error('Couldn\'t find ' + filename + '.')));

      case 17:
        context$1$0.next = 19;
        return regeneratorRuntime.awrap(promisify(github.gitdata.getBlob)(addRepo({ sha: sha })));

      case 19:
        blob = context$1$0.sent;
        return context$1$0.abrupt('return', Promise.resolve({
          content: new Buffer(blob.content, 'base64').toString(),
          commit: head.object.sha
        }));

      case 23:
        context$1$0.prev = 23;
        context$1$0.t0 = context$1$0['catch'](5);
        return context$1$0.abrupt('return', Promise.reject(context$1$0.t0));

      case 26:
      case 'end':
        return context$1$0.stop();
    }
  }, null, this, [[5, 23]]);
};