'use strict';

require('babel-core/polyfill');

var _require = require('lodash');

var defaults = _require.defaults;

var GitHubApi = require('github');
var promisify = require('es6-promisify');

var contentFromFilename = require('./content-from-filename');
var updateFileWithContent = require('./update-file-with-content');

module.exports = function callee$0$0(config, callback) {
  var _config, _config$branch, branch, token, transform, github, content, newContent, transformedConfig, commit, _config2, push, pr, newBranch;

  return regeneratorRuntime.async(function callee$0$0$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        _config = config;
        _config$branch = _config.branch;
        branch = _config$branch === undefined ? 'master' : _config$branch;
        token = _config.token;
        transform = _config.transform;
        context$1$0.prev = 5;
        github = new GitHubApi({
          version: '3.0.0'
        });

        github.authenticate({ type: 'oauth', token: token });

        context$1$0.next = 10;
        return regeneratorRuntime.awrap(contentFromFilename(github, config));

      case 10:
        content = context$1$0.sent;
        newContent = transform(content);
        transformedConfig = {};

        if (typeof newContent === 'string') transformedConfig.content = newContent;else transformedConfig = newContent;

        config = defaults(transformedConfig, { sha: content.commit }, config);

        context$1$0.next = 17;
        return regeneratorRuntime.awrap(updateFileWithContent(github, config));

      case 17:
        commit = context$1$0.sent;
        _config2 = config;
        push = _config2.push;
        pr = _config2.pr;
        newBranch = _config2.newBranch;

        if (pr || push || newBranch) {
          context$1$0.next = 24;
          break;
        }

        return context$1$0.abrupt('return', callback(null, commit));

      case 24:
        if (!push) {
          context$1$0.next = 26;
          break;
        }

        return context$1$0.abrupt('return', github.gitdata.updateReference(defaults({
          ref: 'refs/heads/' + branch,
          sha: commit.sha
        }, config), callback));

      case 26:
        if (!newBranch) {
          context$1$0.next = 29;
          break;
        }

        context$1$0.next = 29;
        return regeneratorRuntime.awrap(promisify(github.gitdata.createReference)(defaults({
          sha: commit.sha,
          ref: 'refs/heads/' + newBranch
        }, config)));

      case 29:
        if (pr) {
          context$1$0.next = 31;
          break;
        }

        return context$1$0.abrupt('return', callback(null, { commit: commit }));

      case 31:

        github.pullRequests.create(defaults(pr, config, {
          base: branch,
          head: config.newBranch || commit.sha
        }), callback);
        context$1$0.next = 37;
        break;

      case 34:
        context$1$0.prev = 34;
        context$1$0.t0 = context$1$0['catch'](5);

        callback(context$1$0.t0);

      case 37:
      case 'end':
        return context$1$0.stop();
    }
  }, null, this, [[5, 34]]);
};